/**
 * Component for Tiny!
 */
Crafty.c('Player', {
    init: function() {

        Crafty.sprite(16, "img/tiny-sprite.png", {
            PlayerSprite: [0, 4],
            TinyWalk: [0, 0],
            TinyJump: [1, 0]
        });

        this.addComponent('2D, DOM, Color, Multiway, Gravity, Delay, Collision, SpriteAnimation, TinyWalk, TinyJump');
        //this.reel('PlayerWalk', 1000, [[0, 0]]);
        //this.reel('PlayerUp', 1000, [[1, 0]]);

    },
    setPlatformGameplay: function() {
        this.multiway(3, {UP_ARROW: -90, RIGHT_ARROW: 0, LEFT_ARROW: 180})
        this.bind('Moved', function(from) {
            if (this.hit('Wall')) {
                this.attr({x: from.x, y:from.y});
            }
        });

        this.gravityConst(0.15);
        this.gravity('Floor');
        /*
        this.bind('KeyDown', function(e) {
            if (e.keyCode === Crafty.keys.UP_ARROW)
                this.animate('PlayerGoUp');
        });
        this.bind("KeyUp", function(e) {
            this.animate('PlayerStop');
        }); */
    },
    setOverworldGameplay: function() {
        this.multiway(4, {UP_ARROW: -90, RIGHT_ARROW: 0, LEFT_ARROW: 180, DOWN_ARROW: 90});
        this.antigravity();
        this.bind('Moved', function(from) {
            if (this.hit('Wall')) {
                this.attr({x: from.x, y:from.y});
            }
        });
    },
    reset: function() {
        this.attr({x: 30, y: 30, w: 16, h: 16});

    }
});