Crafty.c('TVSet', {
    season: 'SPRING',
    channels: {
      one: {x: 36 , y: 59},
      two: {x: 319, y: 59, startx: 320, starty: 72},
      three: {x: 315, y: 255, startx: 466, starty: 253},
      four: {x: 36, y: 255, startx: 290, starty: 366}
    },
    player: null,
    text: null, // narrator
    buttons: 0,
    fez: false,
    transition: false, // prevent duplicate events
    init: function() {
        this.addComponent('2D, Image, Sprite, Mouse, Delay');
        this.attr({w: 640, h:480});

        Crafty.background('#ffffff url(img/tvshows-bg.png)');
        Crafty.e('2D, DOM, Image, Tween, SpringHidden').image('img/spring-hidden.png').attr({x: this.channels.one.x, y: this.channels.one.y});
        Crafty.e('2D, DOM, Image, Tween, SummerHidden').image('img/summer-hidden.png').attr({x: this.channels.two.x, y: this.channels.two.y});
        Crafty.e('2D, DOM, Image, Tween, FallHidden').image('img/fall-hidden.png').attr({x: this.channels.three.x, y: this.channels.three.y});
        Crafty.e('2D, DOM, Image, Tween, WinterHidden').image('img/winter-hidden.png').attr({x: this.channels.four.x, y: this.channels.four.y});

        // Load Sprite Sheets
        Crafty.sprite(24, 28, "img/carrot-missing-sprite.png", {
            CarrotMissingSprite: [[0, 0],[1,0]]
        });
        Crafty.sprite(18, 27, "img/summer-cactus.png", {
            Cactus: [0,0]
        });

        this._spring_intro();
    },
    _spring_intro: function() {
        this.text = Crafty.e('2D, DOM, Color, Image, Tween')
            .image('img/story1.png');
        // this.text = this._draw_text(70, 200, "<center>Tiny began his adventure in the spring...<br/>when the land was new.</center>");
        this.one('Click', function() {
            this._spring_load();
        });
        this.one('KeyDown', function() {
            this._spring_load();
        });
    },
    _spring_load: function() {
        if (this.transition)
            return;
        this.transition = true;
        Crafty('TVSet').text.tween({alpha: 0}, 500)
            .one('TweenEnd', function() {
                Crafty('TVSet').transition = false;
                Crafty('TVSet')._spring();
                this.destroy();
            })
    },
    _spring: function() {
        Crafty('SpringHidden').tween({alpha:0.1}, 300);

        // Ground floor
        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: 37, y: 250, w: 280, h: 10});

        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: 64, y: 225, w: 35, h: 1});

        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: 125, y: 212, w: 35, h: 1});

        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: 204, y: 193, w: 40, h: 1});

        // Cloud platforms
        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: 146, y: 154, w: 40, h: 1});

        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: 53, y: 138, w: 43, h: 1});

        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: 147, y: 97, w: 43, h: 1});

        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: 253, y: 89, w: 65, h: 1});

        // Left Wall
        Crafty.e('Wall, 2D, DOM, Color')
            .attr({x: 35, y: 60, w: 1, h: 200});

        // Right Wall
        Crafty.e('Wall, 2D, DOM, Color')
            .attr({x: 317, y: 60, w: 1, h: 200});

        // Ceiling
        Crafty.e('Wall, 2D, DOM, Color')
            .attr({x: 42, y: 60, w: 277, h: 1});

        this.player = Crafty.e('Player');
        this.player.setPlatformGameplay();
        this.player.attr({x: 43, y: 247, w: 16, h: 16});

        // Carrot
        Crafty.e('2D, DOM, Image, Carrot, Collision, Delay, SolidCarrot')
            .image('img/carrot.png')
            .attr({x: 281, y: 60})
            .onHit('Player', function() {
                Crafty('TVSet').text = Crafty.e('2D, DOM, Color, Image, Tween, DialogPanel')
                    .image('img/story3.png')
                    .bind('KeyDown', function() {
                        Crafty('TVSet').text.tween({alpha: 0}, 500)
                            .one('TweenEnd', function() {
                                Crafty('DialogPanel').destroy();
                                Crafty('TVSet')._summer_load();
                            })
                    })

                // TODO: Play a short happy tune
                this.destroy();
            });

        // Carrot Missing!
        Crafty.e('2D, DOM, SpriteAnimation, Collision, CarrotMissingSprite, CarrotMissing')
            .attr({x: 270, y: 223})
            .reel('CarrotMissingBlink', 1000, [[0, 0], [1, 0]])
            .reel('CarrotMissingStatic', 1000, [[1, 0]])
            .animate('CarrotMissingBlink', -1)
            .onHit('Player', function() {
                var that = Crafty('CarrotMissing');
                if (that.isPlaying('CarrotMissingBlink')) {
                    Crafty('CarrotMissing').animate('CarrotMissingStatic', -1);
                    Crafty('TVSet').text = Crafty.e('2D, DOM, Color, Image, Tween, Mouse, DialogPanel')
                        .image('img/story2.png')
                        .bind('KeyDown', function() {
                            Crafty('TVSet').text.tween({alpha: 0}, 1000)
                                .one('TweenEnd', function() {
                                    if (!Crafty('TVSet').carrotBlink) {
                                        Crafty('SolidCarrot').delay(function() {
                                            var c = Crafty('SolidCarrot');
                                            c.attr({'alpha': (c._alpha == 0 ? 1 : 0)});
                                        }, 750, -1);
                                        Crafty('TVSet').carrotBlink = true;
                                    }
                                    Crafty('DialogPanel').destroy();
                                });

                        })
                }
            });


    },
    _summer_load: function() {
        if (this.season === 'SUMMER')
            return;
        this.season = 'SUMMER';
        Crafty('CarrotMissing').destroy();
        Crafty('SpringHidden').tween({alpha:0.8}, 300);
        Crafty('SummerHidden').tween({alpha:0.1}, 300);
        Crafty('TVSet')._summer();
    },
    _summer: function() {
        // Collect five buttons!
        this.buttons = 0;

        this.player.setOverworldGameplay();
        this.player.attr({x: this.channels.two.startx, y: this.channels.two.starty});

        // Ceiling
        Crafty.e('Wall, 2D, DOM, Color')
            .attr({x: this.channels.two.x, y: 60, w: 277, h: 1});

        // Right Wall
        Crafty.e('Wall, 2D, DOM, Color')
            .attr({x: 595, y: 60, w: 1, h: 190});

        // Floor
        Crafty.e('Wall, 2D, DOM, Color')
            .attr({x: this.channels.two.x, y: 250, w: 277, h: 1});

        // Generate snowman eyes and buttons!
        for (var i = 0; i < 5; i++) {
            Crafty.e('2D, DOM, Color, Collision, Button')
                .attr({x: Crafty.math.randomInt(this.channels.two.x + 20, 320 + 250), y: Crafty.math.randomInt(75, 70 + 150), w: 4, h: 5})
                .color('black')
                .onHit('Player', function(e) {
                    // TODO: Make a happy sound
                    // TODO: Can we fance the graphics of these up a bit?
                    Crafty('TVSet').buttons++;
                    this.destroy();

                    // TODO: Set to five and shave the cactus and player a bit
                    if (5 === Crafty('TVSet').buttons) {
                        Crafty.e('2D, DOM, Image, Oasis, Collision')
                            .attr({x: 420, y: 233})
                            .image('img/summer-oasis.png')
                            .onHit('Player', function() {
                                Crafty('Oasis').destroy();
                                Crafty('TVSet').text = Crafty.e('2D, DOM, Color, Image, Tween, Delay, DialogPanel')
                                    .image('img/story4.png')
                                    .tween({alpha: 1}, 1500)
                                    .bind('KeyDown', function() {
                                        Crafty('DialogPanel').destroy();
                                        Crafty('TVSet')._fall_load();
                                    });
                            })

                    }
                });
        }

        // Generate cactus!
        for (var i = 0; i < 10; i++) {
            Crafty.e('2D, DOM, Cactus, Collision')
                .attr({x: Crafty.math.randomInt(this.channels.two.x + 20, 320 + 250), y: Crafty.math.randomInt(75, 70 + 150)})
                .onHit('Cactus', function(e) {
                    this.destroy();
                })
                .onHit('Button', function(e) {
                    this.destroy();
                })
                .onHit('Oasis', function(e) {
                    this.destroy();
                })
                .onHit('Player', function(e) {
                    // Make an unhappy sound
                    Crafty('Player').attr({x: Crafty('TVSet').channels.two.startx, y: Crafty('TVSet').channels.two.starty});
                });
        }

    },
    _fall_load: function() {
        if (this.season === 'FALL')
            return;
        this.season = 'FALL';
        Crafty('SummerHidden').destroy();
        Crafty.e('2D, DOM, Image, Tween, SummerHidden').image('img/summer-hidden.png').attr({x: this.channels.two.x, y: this.channels.two.y});
        Crafty('SummerHidden').tween({alpha:0.8}, 300);
        Crafty('FallHidden').tween({alpha:0.1}, 300);
        this._fall();
    },

    _fall: function() {

        // Platform settings
        this.player.setPlatformGameplay();
        this.player.attr({x: this.channels.three.startx, y: this.channels.three.starty});

        // Floor
        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: this.channels.two.x, y: 354, w: 277, h: 1});

        // Right Wall
        Crafty.e('Wall, 2D, DOM, Color')
            .attr({x: 595, y: this.channels.three.y, w: 1, h: 190});

        // Left Portal
        Crafty.e('2D, DOM, Color, Collision')
            .attr({x: 320, y: this.channels.three.y, w: 1, h: 190})
            .onHit('Player', function() {
                Crafty('TVSet').text = Crafty.e('2D, DOM, Color, Image, Tween, DialogPanel')
                    .image('img/story5.png')
                    .bind('KeyDown', function() {
                        Crafty('TVSet').text.tween({alpha: 0}, 500)
                            .bind('TweenEnd', function() {
                                Crafty('DialogPanel').destroy();
                                Crafty('TVSet')._winter_load();
                            })
                    });
            });

        // Leaves
        Crafty.e('2D, DOM, Color, Leaves')
            .attr({x: 320, y: this.channels.three.y + 20}).blow();

        Crafty.e('2D, DOM, Color, Leaves')
            .attr({x: 320, y: this.channels.three.y + 50}).blow();

        Crafty.e('2D, DOM, Color, Leaves')
            .attr({x: 320, y: this.channels.three.y + 70}).blow();

        // Fez
        Crafty.e('2D, DOM, Image, Collision')
            .attr({x: 575, y: 335})
            .image('img/fez.png')
            .onHit('Player', function() {
                Crafty('TVSet').fez = true;
                this.destroy();
                // TODO: Play a nice tune

            });

        // TODO: Play wind blowing sounds

        // TODO: Animated Fez from the wind (end part animates)

        // TODO: Might be fun to have a bird the player can chase for the fez

        // The player will be shifted to the right by the wind.

        this.windDelay = function() {
            var p = Crafty('Player');
            if (p._x < 320) {
                return; // in winter, haven't figured out how to cancel this because cancelDelay seems missing
            }
            if (p._x < 464 && Crafty('TVSet').fez === false)
                p.attr({x: p._x + 3});
            else if (p._x < 464)
                p.attr({x: p._x + 2});
            else if (p._x < 573)
                p.attr({x: p._x + 1});
        }

        this.delay(this.windDelay, 10, -1);

        // TODO: When you finish this level it starts to snow and you become lost...  (maybe have a whiteout effect for transition)
    },
    _winter_load: function() {
        if (this.season === 'WINTER')
            return;
        this.season = 'WINTER';
        Crafty('Leaves').destroy();
        Crafty('FallHidden').tween({alpha:0.8}, 300);
        Crafty('WinterHidden').tween({alpha:0.1}, 300);
        // Crafty('TVSet').cancelDelay(Crafty('TVSet').windDelay); missing from crafty?
        this._winter();
    },
    _winter: function() {
        this.player.setPlatformGameplay();
        this.player.attr({x: this.channels.four.startx, y: this.channels.four.starty});

        // Floor
        Crafty.e('Floor, 2D, DOM, Color')
            .attr({x: this.channels.four.x, y: 386, w: 280, h: 1});

        // Left Wall
        Crafty.e('Wall, 2D, DOM, Color, Collision')
            .attr({x: 315, y: this.channels.three.y, w: 1, h: 190});

        // Right Wall
        Crafty.e('Wall, 2D, DOM, Color, Collision')
            .attr({x: 38, y: this.channels.three.y, w: 1, h: 190});

        // Let it snow
        Crafty.e('Snow').attr({x: 240, y: 265}).snow();
        Crafty.e('Snow').attr({x: 220, y: 265}).snow();
        Crafty.e('Snow').attr({x: 180, y: 265}).snow();
        Crafty.e('Snow').attr({x: 120, y: 265}).snow();
        Crafty.e('Snow').attr({x: 80, y: 265}).snow();

        Crafty.e('2D, DOM, Image, Collision')
            .attr({x: 48, y: 308})
            .image('img/snowman-blank.png')
            .onHit('Player', function() {
                this.destroy();
                Crafty.e('2D, DOM, Image')
                    .attr({x: 48, y: 308})
                    .image('img/snowman-dressed.png');

                // TODO:  Happy sound and end of game stuff here

                // Show the end of the game after a second
                Crafty('TVSet').delay(function() {
                    Crafty('TVSet').text = Crafty.e('2D, DOM, Color, Image, Tween, Mouse')
                        .attr({alpha: 0})
                        .image('img/story6.png')
                        .tween({alpha: 1}, 500);
                }, 1000);
            });



    },
    _draw_text: function(x, y, text) {
        return Crafty.e('2D, DOM, Text, Delay, Tween')
            .attr({x: x, y: y, w: 500, h: 100})
            .textColor('#FFFFFF')
            .textFont({ size: '20px' })
            .text(text);
    }
});